// DinamicsTest.cpp : implementation file
//

#include "stdafx.h"
#include "MYTESTER.h"
#include "mt.h"
#include "DinamicsTest.h"
#include "ommentDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// DinamicsTest dialog


DinamicsTest::DinamicsTest(CWnd* pParent /*=NULL*/)
	: CDialog(DinamicsTest::IDD, pParent)
{
	//{{AFX_DATA_INIT(DinamicsTest)
	m_BeginFREQ = 0;
	m_BeginFUEL = 0.0f;
	m_BeginSPEED = 0;
	m_EndAIR = 0.0f;
	m_EndFREQ = 0;
	m_EndFUEL = 0.0f;
	m_EndSPEED = 0;
	m_SAVE = TRUE;
	m_STARTFREQ = 2000;
	m_STOPFREQ = 5500;
	m_TESTTIME = 0.0f;
	m_BeginAIR = 0.0f;
	m_EndFUELK = 0.0f;
	m_BeginFUELK = 0.0f;
	m_SPEEDACC = 0.0f;
	m_FREQACC = 0.0f;
	m_TWATCH = 0;
	//}}AFX_DATA_INIT
	Gear=0;
}


void DinamicsTest::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DinamicsTest)
	DDX_Control(pDX, ID_START_BUTTON, m_START_BUTTONc);
	DDX_Control(pDX, IDC_START_FREQ, m_STARTFREQc);
	DDX_Control(pDX, IDC_STOP_FREQ, m_STOPFREQc);
	DDX_Control(pDX, IDC_GEAR4, m_G4);
	DDX_Control(pDX, IDC_GEAR3, m_G3);
	DDX_Control(pDX, IDC_GEAR2, m_G2);
	DDX_Control(pDX, IDC_GEAR1, m_G1);
	DDX_Text(pDX, IDC_BEGIN_FREQ, m_BeginFREQ);
	DDX_Text(pDX, IDC_BEGIN_FUEL, m_BeginFUEL);
	DDX_Text(pDX, IDC_BEGIN_SPEED, m_BeginSPEED);
	DDX_Text(pDX, IDC_END_AIR, m_EndAIR);
	DDX_Text(pDX, IDC_END_FREQ, m_EndFREQ);
	DDX_Text(pDX, IDC_END_FUEL, m_EndFUEL);
	DDX_Text(pDX, IDC_END_SPEED, m_EndSPEED);
	DDX_Check(pDX, IDC_SAVE, m_SAVE);
	DDX_Text(pDX, IDC_START_FREQ, m_STARTFREQ);
	DDX_Text(pDX, IDC_STOP_FREQ, m_STOPFREQ);
	DDX_Text(pDX, IDC_TEST_TIME, m_TESTTIME);
	DDX_Text(pDX, IDC_BEGIN_AIR, m_BeginAIR);
	DDX_Text(pDX, IDC_END_FUELK, m_EndFUELK);
	DDX_Text(pDX, IDC_BEGIN_FUELK, m_BeginFUELK);
	DDX_Text(pDX, IDC_SPEED_ACC, m_SPEEDACC);
	DDX_Text(pDX, IDC_FREQ_ACC, m_FREQACC);
	DDX_Text(pDX, IDC_TWATCH, m_TWATCH);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DinamicsTest, CDialog)
	//{{AFX_MSG_MAP(DinamicsTest)
	ON_BN_CLICKED(ID_START_BUTTON, OnStartButton)
	ON_BN_CLICKED(IDC_GEAR1, OnGear1)
	ON_BN_CLICKED(IDC_GEAR2, OnGear2)
	ON_BN_CLICKED(IDC_GEAR3, OnGear3)
	ON_BN_CLICKED(IDC_GEAR4, OnGear4)
	ON_BN_CLICKED(IDC_SPEED, OnSpeed)
	ON_EN_CHANGE(IDC_START_FREQ, OnChangeStartFreq)
	ON_EN_CHANGE(IDC_STOP_FREQ, OnChangeStopFreq)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DinamicsTest message handlers

#define MAX_LOOP	2000

extern mt *Tstr;
extern CString	Filename;
extern char szFilter[];
extern BOOL		IdleTimer;

void DinamicsTest::OnStartButton() 
{
char Res;	
FILE	*stream;
time_t	ltime;
DTDUMP *DumpStart,*DumpPtr;

if ((m_STOPFREQ) > 6000) {MessageBox("     6000.","  ", MB_OK | MB_ICONSTOP ); return;}
if ((m_STARTFREQ) < 1000) {MessageBox("      1000.","  ", MB_OK | MB_ICONSTOP ); return;}
if ((m_STOPFREQ<=m_STARTFREQ)) {MessageBox("          1000.","  ", MB_OK | MB_ICONSTOP ); return;}
if ((m_STOPFREQ-m_STARTFREQ)<1000) {MessageBox("          1000.","  ", MB_OK | MB_ICONSTOP ); return;}
	DTPar.StartFREQ=m_STARTFREQ;
	DTPar.StopFREQ=m_STOPFREQ;
	m_START_BUTTONc.EnableWindow(FALSE);
	
	DumpPtr=DumpStart=(DTDUMP *)malloc(sizeof(DTPar)*(MAX_LOOP+3));
	Res=Tstr->DoDinamicsTest(&DTPar,DumpStart,MAX_LOOP);
	IdleTimer=FALSE;

	m_START_BUTTONc.EnableWindow(TRUE);
	if (Res) 
	{
		free(DumpStart);
		if (Res==-1) {MessageBox("    ","  ", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-2) {MessageBox("     .","  ", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-3) {MessageBox(".    ."," ", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-4) {MessageBox(".    ."," ", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-5) {MessageBox("     ."," ", MB_OK | MB_ICONSTOP ); return;}
	}
	m_TESTTIME=((float)DTPar.TestTime)/1000,0;
	m_BeginFREQ=DTPar.BeginFREQ;
	m_EndFREQ=DTPar.EndFREQ;
	if (Gear!=0) {
		m_BeginSPEED=DTPar.BeginSpeed;
		m_EndSPEED=DTPar.EndSpeed;
		m_SPEEDACC=(float)((float)DTPar.EndSpeed-(float)DTPar.BeginSpeed)/m_TESTTIME;
		m_BeginFUELK=DTPar.BeginFUELK;
		m_EndFUELK=DTPar.EndFUELK;
	}
	m_BeginFUEL=DTPar.BeginFUEL;
	m_EndFUEL=DTPar.EndFUEL;
	m_BeginAIR=DTPar.BeginAIR;
	m_EndAIR=DTPar.EndAIR;
	m_FREQACC =(float)((float)DTPar.EndFREQ-(float)DTPar.BeginFREQ)  /m_TESTTIME;
	m_TWATCH =(DTPar.EndTWAT-DTPar.BeginTWAT);
	UpdateData(FALSE);
	if (m_SAVE)
	{
		if ( Filename.GetLength() < 1 )	{ CFileDialog CF( FALSE, ".tdm", "TSTRDMP", OFN_PATHMUSTEXIST|OFN_NOREADONLYRETURN|OFN_CREATEPROMPT|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, szFilter, NULL );	CF.DoModal(); Filename=CF.GetPathName();}
	
		if( (stream = fopen(Filename,"ab")) == NULL ) {MessageBox("   ."," ", MB_OK | MB_ICONSTOP ); return;}
		else {		
		fprintf(stream, "\r\n\r\n \t ******************************************* \r\n");
		fprintf(stream,         " \t ***     .   *** \r\n");
		fprintf(stream,         " \t ******************************************* \r\n\t\t:");
        time( &ltime ); fprintf(stream, "%.24s\r\n", asctime( localtime( &ltime ) ));
CommentDlg	CD;
	CD.DoModal();
		if (CD.m_Comment.GetLength()!=0) fprintf(stream, ": %s\r\n", CD.m_Comment );

		fprintf(stream,"\r\n\r\n  :\t%.4f\tc.", m_TESTTIME );   

		fprintf(stream,"\r\n    : %4i\t: %4i\t..", DTPar.BeginTWAT, DTPar.EndTWAT );
		fprintf(stream,"\r\n         : %4u\t: %4u\t./.", m_BeginFREQ, m_EndFREQ );   
		if (Gear!=0) {
		fprintf(stream,"\r\n                : %3u\t: %3u\t./.", m_BeginSPEED,m_EndSPEED );   
		fprintf(stream,"\r\n              : %.3f\t: %.3f\t./100.", m_BeginFUELK,m_EndFUELK );   
		}
		fprintf(stream,"\r\n             : %.3f\t: %.3f\t./.", m_BeginAIR, m_EndAIR );   
		fprintf(stream,"\r\n              : %.2f\t: %.2f\t./.",  m_BeginFUEL, m_EndFUEL );

		fprintf(stream,"\r\n\r\n   :\t\t%.4f\t(./)/c.", m_FREQACC );   
		if (Gear!=0) 
		{ 
			fprintf(stream,"\r\n  :\t\t\t%.4f\t(./)/.", m_SPEEDACC );   
			fprintf(stream,"  : %.1x.", (int)Gear );   

		}
		fprintf(stream,"\r\n    : %i\t\t../c", m_TWATCH );

char *strptr;
		strptr=(char *)malloc(256);	*strptr=0;
		
		strcpy (strptr,asctime(localtime(&ltime )) ); 
		sprintf(strptr,"%lu",time( &ltime ));
		strcat (strptr,".dmp");
			
		fprintf(stream,"\r\n  : %s", strptr );

		fclose(stream);

		if( (stream = fopen(strptr,"ab")) == NULL ) {MessageBox("    ."," ", MB_OK | MB_ICONSTOP ); 
														free(strptr);free(DumpStart);return;}
		else {		
			fprintf(stream, "\r\n\r\n \t **************************************************************** \r\n");
			fprintf(stream,         " \t ***         Exel.   *** \r\n");
			fprintf(stream,         " \t **************************************************************** \r\n\t\t:");
			time( &ltime ); fprintf(stream, "%.24s\r\n", asctime( localtime( &ltime ) ));

			fprintf(stream,"\r\n   \t  \t \t  \t  \t  \t  ms.\r\n");
		
		do {
			fprintf(stream,"%i\t%u\t%u\t%0.4f\t%0.4f\t%0.3f\t%lu\r\n", DumpPtr->TWAT, DumpPtr->FREQ, DumpPtr->Speed, 
															 DumpPtr->FUELK, DumpPtr->AIR, DumpPtr->FUEL, DumpPtr->Time);
			DumpPtr++;
		} while (DumpPtr->FILL==TRUE);
			fclose(stream);
			free(strptr);
			free(DumpStart);
		}
		
	}
	}
}

void DinamicsTest::OnGear1() {	Gear=1;}
void DinamicsTest::OnGear2() {	Gear=2;}
void DinamicsTest::OnGear3() {	Gear=3;}
void DinamicsTest::OnGear4() {	Gear=4;}

void DinamicsTest::OnSpeed() 
{	m_G1.EnableWindow(TRUE);m_G2.EnableWindow(TRUE);m_G3.EnableWindow(TRUE);m_G4.EnableWindow(TRUE);
	Gear=2; m_G2.SetCheck(TRUE); 

}

char Stringa[8];

void DinamicsTest::OnChangeStartFreq() 
{
m_STARTFREQc.GetWindowText(Stringa,5); m_STARTFREQ=atoi(Stringa); m_STARTFREQc.UpdateData(TRUE);
	
}

void DinamicsTest::OnChangeStopFreq() 
{
m_STOPFREQc.GetWindowText(Stringa,5); m_STOPFREQ=atoi(Stringa); m_STOPFREQc.UpdateData(TRUE);
	
}
