// AccTest.cpp : implementation file
//

#include "stdafx.h"
#include "MYTESTER.h"
#include "mt.h"
#include "AccTest.h"
#include "ommentDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AccTest dialog


AccTest::AccTest(CWnd* pParent /*=NULL*/)
	: CDialog(AccTest::IDD, pParent)
{
	//{{AFX_DATA_INIT(AccTest)
	m_SPEEDACC = 0.0f;
	m_BeginFREQ = 0;
	m_EndFREQ = 0;
	m_BeginSPEED = 0;
	m_FREQACC = 0.0f;
	m_Save = TRUE;
	m_STARTFREQ = 20;
	m_STOPFREQ = 80;
	m_TESTTIME = 0.0f;
	m_EndSPEED = 0;
	//}}AFX_DATA_INIT
	Gear=0;
}


void AccTest::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(AccTest)
	DDX_Control(pDX, IDC_BUTTO_ASTART, m_START_BUTTONc);
	DDX_Text(pDX, IDC_ASPEED_ACC, m_SPEEDACC);
	DDX_Text(pDX, IDC_ABEGIN_FREQ, m_BeginFREQ);
	DDX_Text(pDX, IDC_AEND_FREQ, m_EndFREQ);
	DDX_Text(pDX, IDC_ABEGIN_SPEED, m_BeginSPEED);
	DDX_Text(pDX, IDC_AFREQ_ACC, m_FREQACC);
	DDX_Check(pDX, IDC_ASAVE, m_Save);
	DDX_Text(pDX, IDC_START_SPEED, m_STARTFREQ);
	DDX_Text(pDX, IDC_STOP_SPEED, m_STOPFREQ);
	DDX_Text(pDX, IDC_ATEST_TIME, m_TESTTIME);
	DDX_Text(pDX, IDC_AEND_SPEED, m_EndSPEED);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(AccTest, CDialog)
	//{{AFX_MSG_MAP(AccTest)
	ON_BN_CLICKED(IDC_BUTTO_ASTART, OnButtoAstart)
	ON_BN_CLICKED(IDC_AGEAR1, OnAgear1)
	ON_BN_CLICKED(IDC_AGEAR3, OnAgear3)
	ON_BN_CLICKED(IDC_AGEAR4, OnAgear4)
	ON_BN_CLICKED(IDC_AGEAR2, OnAgear2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// AccTest message handlers
#define MAX_LOOP	2000

extern mt *Tstr;
extern CString	Filename;
extern char szFilter[];
extern BOOL		IdleTimer;

void AccTest::OnButtoAstart() 
{
char Res;	
FILE	*stream;
time_t	ltime;
DTDUMP *DumpStart, *DumpPtr;

	UpdateData(TRUE);
if ((m_STOPFREQ==m_STARTFREQ)) {MessageBox("     .","  ", MB_OK | MB_ICONSTOP ); return;}
	DTPar.StartFREQ=m_STARTFREQ;
	DTPar.StopFREQ=m_STOPFREQ;
	m_START_BUTTONc.EnableWindow(FALSE);

	DumpPtr=DumpStart=(DTDUMP *)malloc(sizeof(DTPar)*(MAX_LOOP+3));
	if (m_STOPFREQ>m_STARTFREQ)	 Res=Tstr->DoAAccTest(&DTPar,DumpStart,MAX_LOOP);
							else Res=Tstr->DoLAccTest(&DTPar,DumpStart,MAX_LOOP);

	IdleTimer=FALSE;
	m_START_BUTTONc.EnableWindow(TRUE);
	if (Res) 
	{
		free(DumpStart);
		if (Res==-1) {MessageBox("    ","  ", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-2) {MessageBox("    .","  ", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-3) {MessageBox(".    ."," ", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-4) {MessageBox(".    ."," ", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-5) {MessageBox("     ."," ", MB_OK | MB_ICONSTOP ); return;}
		if (Res==-6) {MessageBox("     .   ."," ", MB_OK | MB_ICONSTOP ); return;}
	}
	m_TESTTIME=((float)DTPar.TestTime)/1000,0;
	m_BeginFREQ=DTPar.BeginFREQ;
	m_EndFREQ=DTPar.EndFREQ;
	m_BeginSPEED=DTPar.BeginSpeed;
	m_EndSPEED=DTPar.EndSpeed;
	m_SPEEDACC=(float)((float)DTPar.EndSpeed-(float)DTPar.BeginSpeed)/m_TESTTIME;
	m_FREQACC =(float)((float)DTPar.EndFREQ-(float)DTPar.BeginFREQ)  /m_TESTTIME;
	UpdateData(FALSE);
	if (m_Save)
	{
		if ( Filename.GetLength() < 1 )	{ CFileDialog CF( FALSE, ".tdm", "TSTRDMP", OFN_PATHMUSTEXIST|OFN_NOREADONLYRETURN|OFN_CREATEPROMPT|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, szFilter, NULL );	CF.DoModal(); Filename=CF.GetPathName();}
	
		if( (stream = fopen(Filename,"ab")) == NULL ) {MessageBox("   ."," ", MB_OK | MB_ICONSTOP ); return;}
		else {		
		fprintf(stream, "\r\n\r\n \t ************************************************** \r\n");
		fprintf(stream,         " \t ***      .   *** \r\n");
		fprintf(stream,         " \t ************************************************** \r\n\t\t:");
        time( &ltime ); fprintf(stream, "%.24s\r\n", asctime( localtime( &ltime ) ));
CommentDlg	CD;
	CD.DoModal();
		if (CD.m_Comment.GetLength()!=0) fprintf(stream, ": %s\r\n", CD.m_Comment );

		fprintf(stream,"\r\n\r\n  :\t%.4f\tc.", m_TESTTIME );   

		fprintf(stream,"\r\n    : %4i\t: %4i\t..", DTPar.BeginTWAT, DTPar.EndTWAT );
		fprintf(stream,"\r\n         : %4u\t: %4u\t./.", m_BeginFREQ, m_EndFREQ );   
		fprintf(stream,"\r\n                : %3u\t: %3u\t./.", m_BeginSPEED,m_EndSPEED );   
		fprintf(stream,"\r\n              : %.3f\t: %.3f\t./100.", DTPar.BeginFUELK,DTPar.EndFUELK );   
		fprintf(stream,"\r\n             : %.3f\t: %.3f\t./.", DTPar.BeginAIR, DTPar.EndAIR );   
		fprintf(stream,"\r\n              : %.2f\t: %.2f\t./.",  DTPar.BeginFUEL, DTPar.EndFUEL );

		fprintf(stream,"\r\n\r\n   :\t\t%.4f\t(./)/c.", m_FREQACC );   
		fprintf(stream,"\r\n  :\t\t\t%.4f\t(./)/.", m_SPEEDACC );   
		fprintf(stream,"  : %.1x.", (int)Gear );   
		fprintf(stream,"\r\n    : %i\t\t../c", (int)(DTPar.EndTWAT-DTPar.BeginTWAT) );

char *strptr;
		strptr=(char *)malloc(256);	*strptr=0;
		
		strcpy (strptr,asctime(localtime(&ltime )) ); 
		sprintf(strptr,"%lu",time( &ltime ));
		strcat (strptr,".dma");
			
		fprintf(stream,"\r\n  : %s", strptr );

		fclose(stream);

		if( (stream = fopen(strptr,"ab")) == NULL ) {MessageBox("    ."," ", MB_OK | MB_ICONSTOP ); 
														free(strptr);free(DumpStart);return;}
		else {		
			fprintf(stream, "\r\n\r\n \t ******************************************************************* \r\n");
			fprintf(stream,         " \t ***        Exel. *** \r\n");
			fprintf(stream,         " \t ******************************************************************* \r\n\t\t:");
			time( &ltime ); fprintf(stream, "%.24s\r\n", asctime( localtime( &ltime ) ));

			fprintf(stream,"\r\n   \t  \t \t  \t  \t  \t  ms.\r\n");
		
		do {
			fprintf(stream,"%i\t%u\t%u\t%0.4f\t%0.4f\t%0.3f\t%lu\r\n", DumpPtr->TWAT, DumpPtr->FREQ, DumpPtr->Speed, 
															 DumpPtr->FUELK, DumpPtr->AIR, DumpPtr->FUEL, DumpPtr->Time);
			DumpPtr++;
		} while (DumpPtr->FILL==TRUE);
			fclose(stream);
			free(strptr);
			free(DumpStart);
		}
	}
	}
}

void AccTest::OnAgear1() {	Gear=1;}
void AccTest::OnAgear2() {	Gear=2;}
void AccTest::OnAgear3() {	Gear=3;}
void AccTest::OnAgear4() {	Gear=4;} 

