// ontroll.cpp : implementation file
//
#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "stdafx.h"
#include "MYTESTER.h"
#include "ontroll.h"
#include "TestingDlg.h"
#include "mt.h"
#include <math.h>
#include <stdlib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Controll dialog
extern mt *Tstr;
extern BOOL	IdleTimer;
extern char	String[200];
extern TestingDlg		*TestingDlgPtr;

Controll	*CtrlDlg;


Controll::Controll(CWnd* pParent /*=NULL*/)
	: CDialog(Controll::IDD, pParent)
{
	//{{AFX_DATA_INIT(Controll)
	m_RDV = Tstr->_RDV;
	m_FREQXX = Tstr->_FREQXX;
	m_UOZC = Tstr->_UOZOC;
	m_JADS = Tstr->_JADS;
	m_JEGR = Tstr->_JEGR;
	m_RCOD = Tstr->_RCOD;
	m_RCOK = Tstr->_RCOK;
	//}}AFX_DATA_INIT

	c_RDV =		m_RDV; 
	c_FREQXX =	m_FREQXX;
	c_UOZC =	m_UOZC;
	c_JADS =	m_JADS;
	c_JEGR =	m_JEGR;
	c_RCOD =	m_RCOD;
	c_RCOK =	m_RCOK;

	String[0]=0;	
	ReadTimerID=1;
	ReadTimer=0;
//    ReadTimer=SetTimer( ReadTimerID, 2000, TimerProc );
	CtrlDlg=this;
}


void Controll::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Controll)
	DDX_Control(pDX, IDC_UOZC, m_UOZCc);
	DDX_Control(pDX, IDC_RCOK, m_RCOKc);
	DDX_Control(pDX, IDC_RCOD, m_RCODc);
	DDX_Control(pDX, IDC_FREQXX, m_FREQXXc);
	DDX_Control(pDX, IDC_RDV, m_RDVc);
	DDX_Text(pDX, IDC_RDV, m_RDV);
	DDX_Text(pDX, IDC_FREQXX, m_FREQXX);
	DDX_Text(pDX, IDC_UOZC, m_UOZC);
	DDX_Text(pDX, IDC_JADS, m_JADS);
	DDV_MinMaxUInt(pDX, m_JADS, 0, 100);
	DDX_Text(pDX, IDC_JEGR, m_JEGR);
	DDV_MinMaxUInt(pDX, m_JEGR, 0, 100);
	DDX_Text(pDX, IDC_RCOD, m_RCOD);
	DDX_Text(pDX, IDC_RCOK, m_RCOK);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Controll, CDialog)
	//{{AFX_MSG_MAP(Controll)
	ON_BN_CLICKED(IDC_RCODUP, OnRcodup)
	ON_BN_CLICKED(IDC_RCODDOWN, OnRcoddown)
	ON_BN_CLICKED(IDC_RCOKUP, OnRcokup)
	ON_BN_CLICKED(IDC_RCOKDOWN, OnRcokdown)
	ON_BN_CLICKED(IDC_UOZCDOWN, OnUozcdown)
	ON_BN_CLICKED(IDC_UOZCUP, OnUozcup)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Controll message handlers


BOOL Controll::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	
//    ReadTimer=KillTimer( ReadTimerID );

	return CDialog::DestroyWindow();
}

void Controll::OnOK() 
{
float	M;
BOOL	Store=FALSE;
//int		i;
	UpdateData(TRUE); 
	if (m_RDV!=c_RDV)		m_RDV=Tstr->OnSaveRdv(m_RDV); 
	if (m_FREQXX!=c_FREQXX)	m_FREQXX=Tstr->OnSaveFreqxx(m_FREQXX);
	if (fabs(m_RCOD-c_RCOD)>0.002)	
	{	
		Store=( MessageBox((LPCTSTR)"         (RCOD)?",
			(LPCTSTR)"   .", (UINT)MB_YESNO) == IDYES);
		m_RCOD=Tstr->RCOxChg(0,m_RCOD);
		M=Tstr->OnSaveRCOD(m_RCOD);
		Sleep(200);
		if (Store)	Tstr->StoreRCOD();
		Sleep(200);
		Tstr->ReadParams();
		if (fabs(m_RCOD-(Tstr->_RCOD))>0.004) { 
			Sleep(100);  
			M=Tstr->OnSaveRCOD(m_RCOD); 
			Sleep(100);
			if (Store)	Tstr->StoreRCOD();
			Sleep(100); 
			Tstr->ReadParams();
			Sleep(200); 
			if (fabs(m_RCOD-(Tstr->_RCOD))>0.004) { 
				M=Tstr->OnSaveRCOD(Tstr->RCOxChg(1,0));
				Sleep(200);
				if (Store)	Tstr->StoreRCOD();
			}
		}
	
	}
	if (fabs(m_RCOK-c_RCOK)>0.002)	
	{	
		Store=( MessageBox((LPCTSTR)"       (RCOK)?",
			(LPCTSTR)"   .", (UINT)MB_YESNO) == IDYES);

		m_RCOK=Tstr->RCOxChg(0,m_RCOK);
		M=Tstr->OnSaveRCOK(m_RCOK);
		Sleep(300);
		if (Store)	Tstr->StoreRCOK();
		Sleep(300);
		Tstr->ReadParams();
		if (fabs(m_RCOK-(Tstr->_RCOK))>0.004) { 
			Sleep(200);  
			M=Tstr->OnSaveRCOK(m_RCOK); 
			Sleep(300);
			if (Store)	Tstr->StoreRCOK();
			Sleep(200); 
			Tstr->ReadParams();
			Sleep(200); 
			if (fabs(m_RCOK-(Tstr->_RCOK))>0.004) { 
				M=Tstr->OnSaveRCOK(Tstr->RCOxChg(1,0));
				Sleep(300);
				if (Store)	Tstr->StoreRCOK();
			}
		}
	}
	if (m_JEGR!=c_JEGR)	m_JEGR=Tstr->OnSaveJEGR(m_JEGR);
	if (m_JADS!=c_JADS)	m_JEGR=Tstr->OnSaveJADS(m_JADS);
	if (fabs(m_UOZC-c_UOZC)>0.01)		
		{m_UOZC=Tstr->OnSaveUOZC(m_UOZC); 
		if ( MessageBox((LPCTSTR)"       ?",
			(LPCTSTR)"   .", (UINT)MB_YESNO) == IDYES) 
					Tstr->StoreUOZC();
		}
	TestingDlgPtr->m_ReturnCtrl.EnableWindow(TRUE);
	
	CDialog::OnOK();
}


BOOL Controll::OnInitDialog() 
{
	CDialog::OnInitDialog();
	

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void Controll::OnRcodup() 
{
// signed char M=-11,pos=0;
// unsigned char N=0;
//			float Et,m=0;
//m=-0.0977;
// N=M;
	char	String[50];
		m_RCODc.GetWindowText(String,40); 
		m_RCOD=atof(String);	
		m_RCOD=Tstr->RCOxChg(1, m_RCOD);
		
		Tstr->OnSaveRCOD(m_RCOD);

		m_RCODc.UpdateData(TRUE);
		sprintf(String,"%.6f",m_RCOD);
		m_RCODc.SetWindowText(String); 
}

void Controll::OnRcoddown() 
{
	char	String[50];
		m_RCODc.GetWindowText(String,40); 
		m_RCOD=atof(String);	
		m_RCOD=Tstr->RCOxChg(-1, m_RCOD);

		Tstr->OnSaveRCOD(m_RCOD);

		m_RCODc.UpdateData(TRUE);
		sprintf(String,"%.6f",m_RCOD);
		m_RCODc.SetWindowText(String); 
	
}

void Controll::OnRcokup() 
{
	char	String[50];
		m_RCOKc.GetWindowText(String,40); 
		m_RCOK=atof(String);	
		m_RCOK=Tstr->RCOxChg(1, m_RCOK);

		Tstr->OnSaveRCOK(m_RCOK);

		m_RCOKc.UpdateData(TRUE);
		sprintf(String,"%.6f",m_RCOK);
		m_RCOKc.SetWindowText(String); 
}

void Controll::OnRcokdown() 
{
	char	String[50];
		m_RCOKc.GetWindowText(String,40); 
		m_RCOK=atof(String);	
		m_RCOK=Tstr->RCOxChg(-1, m_RCOK);

		Tstr->OnSaveRCOK(m_RCOK);

		m_RCOKc.UpdateData(TRUE);
		sprintf(String,"%.6f",m_RCOK);
		m_RCOKc.SetWindowText(String); 
}


void Controll::OnUozcdown() 
{
char	String[50];
		m_UOZCc.GetWindowText(String,40); 
		m_UOZC=atof(String);	
		m_UOZC=m_UOZC-0.5;
		if (m_UOZC<-15) m_UOZC=-15;

	Tstr->OnSaveUOZC(m_UOZC);
	Sleep(100);
	Tstr->ReadParams();
	m_UOZC=Tstr->_UOZOC;

		m_UOZCc.UpdateData(TRUE);
		sprintf(String,"%.1f",m_UOZC);
		m_UOZCc.SetWindowText(String); 
}

void Controll::OnUozcup() 
{
char	String[50];
		m_UOZCc.GetWindowText(String,40); 
		m_UOZC=atof(String);	
		m_UOZC=m_UOZC+0.5;
		if (m_UOZC>15) m_UOZC=15;

	Tstr->OnSaveUOZC(m_UOZC);
	Sleep(100);
	Tstr->ReadParams();
	m_UOZC=Tstr->_UOZOC;
		m_UOZCc.UpdateData(TRUE);
		sprintf(String,"%.1f",m_UOZC);
		m_UOZCc.SetWindowText(String); 
	
}
