// TestingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MYTESTER.h"
#include "TestingDlg.h"
#include "ommentDlg.h"
#include "DecodeErrors.h"
#include "DinamicsTest.h"
#include "MechanicTest.h"
#include "ontroll.h"
#include "AccTest.h"
#include "VINDlg.h"
#include "uart.h"

#include "tester.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// TestingDlg dialog

void CALLBACK EXPORT TimerProc(HWND hWnd, UINT nMsg, UINT nIDEvent, DWORD dwTime); 

extern int		COM_Port;
char		BASED_CODE szFilter[] = "   ISO14230 (*.tdm)|*.tdm|  (*.*)|*.*||";

TestingDlg		*TestingDlgPtr;
mt				*Tstr;
BOOL			IdleTimer;
CString			Filename;


/*	struct	CM_COMBO 
		{	int		cm_Index;
			int		cm_Combo_INDEX;
			char	cm_String[60];
		} cm_combo[10] = {	INJ,0,"",	RDV,0,"   ()",UOZOC,0,"  -   (UOZOC)",
					RCOK,0," .  (RCOK)",	RCOD,0," .     (RCOD)",UGB,0,"      (UGB)",
					SSM,0,"   (SSM)", 0,0,0	};
*/

TestingDlg::TestingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(TestingDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(TestingDlg)
	m_FREQ = 0;
	m_INJ = 0.0f;
	m_JAIR = 0.0f;
	m_JQK = 0.0f;
	m_JQT = 0.0f;
	m_NUACC = 0.0f;
	m_SPD = 0;
	m_TAIR = 0;
	m_THR = 0;
	m_UOZ = 0;
	m_VALF = 0.0f;
	m_FSM = 0;
	m_Connected = _T("");
	m_TWAT = 0;
	m_NERRORS = 0;
	m_ERRORS = _T("");
	m_Timer = 2;
	m_F1 = TRUE;
	m_F2 = TRUE;
	m_F3 = TRUE;
	m_F4 = TRUE;
	m_I14 = TRUE;
	m_I23 = TRUE;
	m_EBN = FALSE;
	m_CHECKEIGINE = FALSE;
	m_CONDITION = FALSE;
	m_ADSORBER = FALSE;
	m_FAN = FALSE;
	m_M154N = FALSE;
	m_BITPOW = FALSE;
	m_BITSTP = FALSE;
	m_BLKINJ = FALSE;
	m_DET = FALSE;
	m_RXX = FALSE;
	m_WRKLAM = FALSE;
	m_RDET = FALSE;
	m_FAZ = 0;
	m_ATM = FALSE;
	m_LAM1 = 0;
	m_LAM2 = 0;
	m_LAM1S = FALSE;
	m_JDMM = 0;
	m_COEFF1 = 0.0f;
	m_COEFF2 = 0.0f;
	m_BDET = 0;
	m_UGB = 0.0f;
	m_UOZOC = 0.0f;
	m_Deton = TRUE;
	m_LZond = TRUE;
	m_RCOK = 0.0f;
	//}}AFX_DATA_INIT
	TestingDlgPtr=this;
	COM_Port=0;
	Regen=0;
	ReadTimerID=1; ReadTimer=0;
	TmPeriod=1000;
	Started=IdleTimer=FALSE;	
	Tstr=&Tester;
	CntrlsEnabled=FALSE;
}


void TestingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(TestingDlg)
	DDX_Control(pDX, IDC_CLRLAM, m_CLRLAM);
	DDX_Control(pDX, IDC_CLRDET, m_CLRDET);
	DDX_Control(pDX, IDC_LZOND, m_LZondc);
	DDX_Control(pDX, IDC_DETON, m_Detonc);
	DDX_Control(pDX, IDC_CONTROL_BUTTON, m_CONTROL_BUTTON);
	DDX_Control(pDX, IDC_ACC_BUTTON, m_ACC_BUTTONc);
	DDX_Control(pDX, IDC_MECH_BUTTON, m_MECH_BUTTON);
	DDX_Control(pDX, IDC_BUTTON_CLRERR, m_CLEARERR_BUTTON);
	DDX_Control(pDX, IDC_BUTTON_DECODEERR, m_DECODEERR_BUTTON);
	DDX_Control(pDX, IDC_IDENT_BUTTON, m_IDENT_BUTTON);
	DDX_Control(pDX, IDC_COM, m_COMc);
	DDX_Control(pDX, IDC_SAVE_BUTTON, m_SAVE_BUTTON);
	DDX_Control(pDX, IDC_TEST_BUTTON, m_TEST_BUTTON);
	DDX_Control(pDX, IDC_M154N, m_M154Nc);
	DDX_Control(pDX, IDC_FAN, m_FANc);
	DDX_Control(pDX, IDC_ADSORBER, m_ADSORBERc);
	DDX_Control(pDX, IDC_CONDITION, m_CONDITIONc);
	DDX_Control(pDX, IDC_CHECKEIGINE, m_CHECKEIGINEc);
	DDX_Control(pDX, IDC_EBN, m_EBNc);
	DDX_Control(pDX, IDC_I23, m_I23c);
	DDX_Control(pDX, IDC_I14, m_I14c);
	DDX_Control(pDX, IDC_F4, m_F4c);
	DDX_Control(pDX, IDC_F3, m_F3c);
	DDX_Control(pDX, IDC_F2, m_F2c);
	DDX_Control(pDX, IDC_F1, m_F1c);
	DDX_Control(pDX, IDC_ReturnCtrl, m_ReturnCtrl);
	DDX_Control(pDX, IDC_SPIN3, m_SpinButton);
	DDX_Control(pDX, IDSTART, m_START_BUTTON);
	DDX_Text(pDX, IDC_FREQ, m_FREQ);
	DDX_Text(pDX, IDC_INJ, m_INJ);
	DDX_Text(pDX, IDC_JAIR, m_JAIR);
	DDX_Text(pDX, IDC_JQK, m_JQK);
	DDX_Text(pDX, IDC_JQT, m_JQT);
	DDX_Text(pDX, IDC_NUACC, m_NUACC);
	DDX_Text(pDX, IDC_SPD, m_SPD);
	DDX_Text(pDX, IDC_TAIR, m_TAIR);
	DDX_Text(pDX, IDC_THR, m_THR);
	DDX_Text(pDX, IDC_UOZ, m_UOZ);
	DDX_Text(pDX, IDC_VALF, m_VALF);
	DDX_Text(pDX, IDC_FSM, m_FSM);
	DDX_Text(pDX, IDC_Connected, m_Connected);
	DDX_Text(pDX, IDC_TWAT, m_TWAT);
	DDX_Text(pDX, IDC_NERROS, m_NERRORS);
	DDX_Text(pDX, IDC_ERRORS, m_ERRORS);
	DDX_Text(pDX, IDC_Timer, m_Timer);
	DDV_MinMaxInt(pDX, m_Timer, 0, 4);
	DDX_Check(pDX, IDC_F1, m_F1);
	DDX_Check(pDX, IDC_F2, m_F2);
	DDX_Check(pDX, IDC_F3, m_F3);
	DDX_Check(pDX, IDC_F4, m_F4);
	DDX_Check(pDX, IDC_I14, m_I14);
	DDX_Check(pDX, IDC_I23, m_I23);
	DDX_Check(pDX, IDC_EBN, m_EBN);
	DDX_Check(pDX, IDC_CHECKEIGINE, m_CHECKEIGINE);
	DDX_Check(pDX, IDC_CONDITION, m_CONDITION);
	DDX_Check(pDX, IDC_ADSORBER, m_ADSORBER);
	DDX_Check(pDX, IDC_FAN, m_FAN);
	DDX_Check(pDX, IDC_M154N, m_M154N);
	DDX_Check(pDX, IDC_BITPOW, m_BITPOW);
	DDX_Check(pDX, IDC_BITSTP, m_BITSTP);
	DDX_Check(pDX, IDC_BLKINJ, m_BLKINJ);
	DDX_Check(pDX, IDC_DET, m_DET);
	DDX_Check(pDX, IDC_RXX, m_RXX);
	DDX_Check(pDX, IDC_WRKLAM, m_WRKLAM);
	DDX_Check(pDX, IDC_RDET, m_RDET);
	DDX_Text(pDX, IDC_FAZ, m_FAZ);
	DDX_Check(pDX, IDC_ATM, m_ATM);
	DDX_Text(pDX, IDC_LAM1, m_LAM1);
	DDX_Text(pDX, IDC_LAM2, m_LAM2);
	DDX_Check(pDX, IDC_LAM1S, m_LAM1S);
	DDX_Text(pDX, IDC_JDMM, m_JDMM);
	DDX_Text(pDX, IDC_COEFF1, m_COEFF1);
	DDX_Text(pDX, IDC_COEFF2, m_COEFF2);
	DDX_Text(pDX, IDC_BDET, m_BDET);
	DDX_Text(pDX, IDC_UGB, m_UGB);
	DDX_Text(pDX, IDC_UOZOC, m_UOZOC);
	DDX_Check(pDX, IDC_DETON, m_Deton);
	DDX_Check(pDX, IDC_LZOND, m_LZond);
	DDX_Text(pDX, IDC_RCOKI, m_RCOK);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(TestingDlg, CDialog)
	//{{AFX_MSG_MAP(TestingDlg)
	ON_BN_CLICKED(IDSTART, OnStart)
	ON_EN_CHANGE(IDC_Timer, OnChangeTimer)
	ON_BN_CLICKED(IDC_BUTTON_CLRERR, OnButtonClrerr)
	ON_BN_CLICKED(IDC_F1, OnF1)
	ON_BN_CLICKED(IDC_BUTTON_DECODEERR, OnButtonDecodeerr)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_ReturnCtrl, OnReturnCtrl)
	ON_BN_CLICKED(IDC_F2, OnF2)
	ON_BN_CLICKED(IDC_F3, OnF3)
	ON_BN_CLICKED(IDC_F4, OnF4)
	ON_BN_CLICKED(IDC_I14, OnI14)
	ON_BN_CLICKED(IDC_I23, OnI23)
	ON_BN_CLICKED(IDC_CHECKEIGINE, OnCheckeigine)
	ON_BN_CLICKED(IDC_EBN, OnEbn)
	ON_BN_CLICKED(IDC_CONDITION, OnCondition)
	ON_BN_CLICKED(IDC_ADSORBER, OnAdsorber)
	ON_BN_CLICKED(IDC_FAN, OnFan)
	ON_BN_CLICKED(IDC_TEST_BUTTON, OnTestButton)
	ON_BN_CLICKED(IDC_M154N, OnM154n)
	ON_BN_CLICKED(IDC_SAVE_BUTTON, OnSaveButton)
	ON_CBN_SELCHANGE(IDC_COM, OnSelchangeCom)
	ON_BN_CLICKED(IDC_IDENT_BUTTON, OnIdentButton)
	ON_BN_CLICKED(IDC_MECH_BUTTON, OnMechButton)
	ON_BN_CLICKED(IDC_ACC_BUTTON, OnAccButton)
	ON_BN_CLICKED(IDC_COMMANDA, OnCommanda)
	ON_BN_CLICKED(IDC_CONTROL_BUTTON, OnControlButton)
	ON_BN_CLICKED(IDC_LZOND, OnLzond)
	ON_BN_CLICKED(IDC_DETON, OnDeton)
	ON_BN_CLICKED(IDC_CLRLAM, OnClrlam)
	ON_BN_CLICKED(IDC_CLRDET, OnClrdet)
	ON_WM_CANCELMODE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

char String[1220];

void TestingDlg::OnButtonDecodeerr() {DecodeErrors	DEDlg;  DEDlg.DoModal();}

/* BMW specific Part */

/*********************************************************************************/

void TestingDlg::ReadErrors() 
{	
	Tstr->ReadErrors();
	m_NERRORS=Tstr->NErr;
	Tstr->GetERRORS(&m_ERRORS);
}

TestingDlg::DisableControls()  //     
{
	CntrlsEnabled=FALSE;
	m_CLEARERR_BUTTON.EnableWindow(FALSE);
	m_DECODEERR_BUTTON.EnableWindow(FALSE);
	m_IDENT_BUTTON.EnableWindow(FALSE);
	m_MECH_BUTTON.EnableWindow(FALSE);
	m_SAVE_BUTTON.EnableWindow(FALSE);	
	m_TEST_BUTTON.EnableWindow(FALSE);
	m_CONTROL_BUTTON.EnableWindow(FALSE);	
	m_F1c.EnableWindow(FALSE); m_F2c.EnableWindow(FALSE); m_F3c.EnableWindow(FALSE); m_F4c.EnableWindow(FALSE);
	m_I14c.EnableWindow(FALSE); m_I23c.EnableWindow(FALSE); m_EBNc.EnableWindow(FALSE); m_CHECKEIGINEc.EnableWindow(FALSE); 
	m_CONDITIONc.EnableWindow(FALSE); 
	m_ADSORBERc.EnableWindow(FALSE); m_FANc.EnableWindow(FALSE); 
	m_ACC_BUTTONc.EnableWindow(FALSE); 
	m_CLRLAM.EnableWindow(FALSE); 
	m_CLRDET.EnableWindow(FALSE); 
	m_Detonc.EnableWindow(FALSE); 
	m_LZondc.EnableWindow(FALSE); 
}

TestingDlg::EnableControls()  //    
{
	CntrlsEnabled=TRUE;
	m_CLEARERR_BUTTON.EnableWindow(TRUE);
	m_DECODEERR_BUTTON.EnableWindow(TRUE);
	m_IDENT_BUTTON.EnableWindow(TRUE);
	m_MECH_BUTTON.EnableWindow(TRUE);
	m_CONTROL_BUTTON.EnableWindow(TRUE);	
	m_SAVE_BUTTON.EnableWindow(TRUE);	m_TEST_BUTTON.EnableWindow(TRUE);
	m_F1c.EnableWindow(TRUE); 
	if (m_M154N) 
		{ m_F2c.EnableWindow(TRUE); m_F3c.EnableWindow(TRUE); m_F4c.EnableWindow(TRUE);}
	m_I14c.EnableWindow(TRUE);		m_I23c.EnableWindow(TRUE); 
	m_EBNc.EnableWindow(TRUE);		m_CHECKEIGINEc.EnableWindow(TRUE); 
	m_CONDITIONc.EnableWindow(TRUE); m_ADSORBERc.EnableWindow(TRUE); 
	m_FANc.EnableWindow(TRUE); 	m_ACC_BUTTONc.EnableWindow(TRUE); 
	m_CLRLAM.EnableWindow(TRUE); 
	m_CLRDET.EnableWindow(TRUE); 
	m_Detonc.EnableWindow(TRUE); 
	m_LZondc.EnableWindow(TRUE); 
}

/***********************************************************************/

TestingDlg::RefControls() { DisableControls(); if (Tstr->Connected) EnableControls();} 

TestingDlg::UpdateForm(){	UpdateData(FALSE); }
  
TestingDlg::SetTesterStateText() { m_Connected=Tstr->StateText; UpdateData(FALSE); }

/***********************************************************************/

TestingDlg::ReadParams(void)
{
if(!(Tstr->ReadParams()))
{		//    .
	m_TWAT=Tstr->_TWAT;	m_VALF=Tstr->_VALF;	m_THR=Tstr->_THR;
	m_FREQ=Tstr->_FREQ;	
//	if ( !(Tstr->FREQXXChanged) )	m_FREQXX=Tstr->_FREQ;	
//	if ( !(Tstr->RDVChanged)	)	m_RDV=Tstr->_RDV;	

	m_FSM=Tstr->_FSM;	m_COEFF1=Tstr->_COEFF1;		m_COEFF2=Tstr->_COEFF2;	m_UOZ=Tstr->_UOZ;
	m_SPD=Tstr->_SPD;	m_NUACC=Tstr->_NUACC;	m_UOZOC=Tstr->_UOZOC;
	m_INJ=Tstr->_INJ; 
	m_JAIR=Tstr->_JAIR;	m_JQT=Tstr->_JQT;	m_JQK=Tstr->_JQK; m_FAZ=Tstr->_FAZ; m_UGB=Tstr->_UGB; 
	m_LAM1S=Tstr->_INPLAM1;	m_LAM1=Tstr->_LAM1;	m_LAM2=Tstr->_LAM2;
	m_JDMM=Tstr->_JDMM; m_BDET=Tstr->_BDET;
		/*   */
	m_BITPOW=Tstr->_BITPOW; m_RXX=Tstr->_RXX; m_BLKINJ=Tstr->_BLKINJ; m_BITSTP=Tstr->_BITSTP; 
	m_DET=Tstr->_DET; m_WRKLAM=Tstr->_WRKLAM; m_RDET=Tstr->_RDET; m_ATM=Tstr->_BITATM;
	/*  */
	m_CHECKEIGINE=Tstr->_CHECKEIGINE; m_EBN=Tstr->_EBN; m_CONDITION=Tstr->_CONDITION; m_ADSORBER=Tstr->_ADSORBER;
	m_FAN=Tstr->_FAN; m_Connected=Tstr->StateText;
	m_RCOK=Tstr->_RCOK;	m_TAIR=Tstr->_TAIR;

//	Tstr->COMPLECTATION(&m_COMPLECTATION);
	if (Tstr->M154N!=m_M154N)
		{ m_M154N=Tstr->M154N; RefControls(); m_M154Nc.UpdateData(TRUE); }
	return 0;;
	}
return -1;
}

/***********************************************************************/

TestingDlg::SetControls() //   .
{
	Tstr->ReadControls();
	m_F1=Tstr->_F1;			m_F1c.SetCheck(m_F1);
	m_F2=Tstr->_F2;			m_F2c.SetCheck(m_F2);
	m_F3=Tstr->_F3;			m_F3c.SetCheck(m_F3);
	m_F4=Tstr->_F4;			m_F4c.SetCheck(m_F4);
	m_I14=Tstr->_I14;		m_I14c.SetCheck(TRUE);
	m_I23=Tstr->_I23;		m_I23c.SetCheck(TRUE);
	m_EBN=Tstr->_EBN;	m_EBNc.SetCheck(m_EBN);
	m_CONDITION=Tstr->_CONDITION;	m_CONDITIONc.SetCheck(m_CONDITION);
	m_FAN=Tstr->_FAN;	m_FANc.SetCheck(m_FAN);
	m_CHECKEIGINE=Tstr->_CHECKEIGINE;		m_CHECKEIGINEc.SetCheck(m_CHECKEIGINE);
	m_ADSORBER=Tstr->_ADSORBER;		m_ADSORBERc.SetCheck(m_ADSORBER);
	m_LZondc.SetCheck(m_LZond);		m_Detonc.SetCheck(m_Deton);
	
//		if (!Tstr->RDVChanged) {	m_RDV=Tstr->_RDV;	m_RDVc.UpdateData(FALSE);	}
}

/***********************************************************************/

void CALLBACK EXPORT TimerProc(HWND hWnd, UINT nMsg, UINT nIDEvent, DWORD dwTime) 
{
	TestingDlgPtr->osTimerProc();
}

void TestingDlg::osTimerProc()
{
	if( !(Tstr->Connected) ) 
				{ Tstr->TryConnect();
					if (Tstr->Connected) EnableControls(); Regen=3;
				}
	Tstr->TesterPresent();
	if (!IdleTimer) 
	{
		ReadParams();
		if (Regen>2)
		{
			SetTesterStateText();
			Regen=0;
			ReadErrors(); 
			SetControls();
		}
		Regen++;
		TestingDlgPtr->UpdateForm();

//Tstr->Connected=1;

	if (Tstr->Connected) { if ( !CntrlsEnabled )  EnableControls(); }
					else { if (  CntrlsEnabled )  DisableControls();}	
	}
}

/***********************************************************************/

void TestingDlg::OnStart() 
{
	Regen=0;
	m_COMc.EnableWindow(FALSE);
	if (COM_Port==0) { COM_Port=2; m_COMc.SetCurSel(COM_Port-2);}
	Started=TRUE;
	IdleTimer=FALSE;
	Filename="";
	
	Tstr->OnStart();

	m_M154N=Tstr->M154N;
	
	m_START_BUTTON.EnableWindow(FALSE);
	TestingDlgPtr->SetTesterStateText();
	if (Tstr->Connected) 
			{	TestingDlgPtr->EnableControls();	}
	UpdateData(TRUE);
	Sleep(100);

	m_F1=Tstr->_F1;			m_F1c.SetCheck(m_F1);
	m_F2=Tstr->_F2;			m_F2c.SetCheck(m_F2);
	m_F3=Tstr->_F3;			m_F3c.SetCheck(m_F3);
	m_F4=Tstr->_F4;			m_F4c.SetCheck(m_F4);
	m_I14=Tstr->_I14;		m_I14c.SetCheck(m_I14);
	m_I23=Tstr->_I23;		m_I23c.SetCheck(m_I23);
	m_CONDITION=Tstr->_CONDITION;	m_CONDITIONc.SetCheck(m_CONDITION);

	SetControls();
	ReadParams(); 
	ReadErrors(); 

	TestingDlgPtr->UpdateForm();

	ReadTimerID=1;
	ReadTimer=0;
	if (m_Timer>0)		TmPeriod=m_Timer*1000;
				else	TmPeriod=600;
    ReadTimer=SetTimer( ReadTimerID, TmPeriod, TimerProc );
}

/***********************************************************************/

void TestingDlg::OnOK() {	CDialog::OnOK(); }

/***********************************************************************/

void TestingDlg::OnChangeTimer() 
{	
	if (m_SpinButton) m_Timer=m_SpinButton.GetPos();
	if (m_Timer>2)	{ m_Timer=2;	m_SpinButton.SetPos(2);}
//	if (m_Timer==0)	{ m_Timer=1;	m_SpinButton.SetPos(1);}
	if (ReadTimer!=0) {
				if (m_Timer>0) TmPeriod=m_Timer*1000;
						else	TmPeriod=600;
				KillTimer(ReadTimer);
				ReadTimer=SetTimer( ReadTimerID, TmPeriod, TimerProc );
	}
}

/***********************************************************************/

void TestingDlg::OnButtonClrerr() 
{	//      clearDiagnosticInformation.
IdleTimer=TRUE;
	Tstr->ClearErr();
	m_NERRORS=0; m_ERRORS=""; 
	TestingDlgPtr->UpdateForm();
IdleTimer=FALSE;
}

/***********************************************************************/

void TestingDlg::OnF1() { 
	Tstr->SetF1(&m_F1); 
	m_ReturnCtrl.EnableWindow(TRUE);
	m_F1c.SetCheck(m_F1); 
//	m_F1c.UpdateData(TRUE);
}

/***********************************************************************/

void TestingDlg::OnF2() { Tstr->SetF2 (&m_F2);  
	m_F2c.SetCheck(m_F2);   
//	m_F2c.UpdateData(TRUE);  
	m_ReturnCtrl.EnableWindow(TRUE);}
void TestingDlg::OnF3() { 
	Tstr->SetF3 (&m_F3); 
	 m_F3c.SetCheck(m_F3);
//	 m_F3c.UpdateData(TRUE);
	 m_ReturnCtrl.EnableWindow(TRUE);}
void TestingDlg::OnF4() { 
	Tstr->SetF4 (&m_F4);
	m_F4c.SetCheck(m_F4);
//	m_F4c.UpdateData(TRUE);
	m_ReturnCtrl.EnableWindow(TRUE);}

void TestingDlg::OnI14(){ Tstr->SetI14(&m_I14); m_I14c.SetCheck(m_I14); m_I14c.UpdateData(TRUE); m_ReturnCtrl.EnableWindow(TRUE); }
void TestingDlg::OnI23(){ Tstr->SetI23(&m_I23); m_I23c.SetCheck(m_I23); m_I23c.UpdateData(TRUE); m_ReturnCtrl.EnableWindow(TRUE);}

/***********************************************************************/

TestingDlg::RetCtrl()
{
	IdleTimer=TRUE;
	Tstr->RetCtrl();
	IdleTimer=FALSE;
		m_F1c.SetCheck(TRUE);m_F2c.SetCheck(TRUE);m_F3c.SetCheck(TRUE);m_F4c.SetCheck(TRUE);
		m_I14c.SetCheck(TRUE);m_I23c.SetCheck(TRUE);
		m_CHECKEIGINEc.SetCheck(FALSE);
		m_EBNc.SetCheck(TRUE);
		m_CONDITIONc.SetCheck(FALSE);
		m_ADSORBERc.SetCheck(FALSE);
		m_FANc.SetCheck(FALSE);
//		m_SET_RDVc.EnableWindow(FALSE);
//		m_SET_FREQXXc.EnableWindow(FALSE);
	SetControls();
	UpdateForm();
	m_ReturnCtrl.EnableWindow(FALSE);
}

/***********************************************************************/

void TestingDlg::OnReturnCtrl() 
{	
	RetCtrl(); 
	IdleTimer=FALSE;
}

/***********************************************************************/

void TestingDlg::OnDestroy() 
{	CDialog::OnDestroy();
	if (Started) 
	{	
		if (ReadTimer!=0) 
				KillTimer(ReadTimer); 
		ReadTimer=0;
		Tstr->Closemt();
	}	
	Started=FALSE;
}

/***********************************************************************/

void TestingDlg::OnCheckeigine() 
{
	Tstr->OnCheckeigine(&m_CHECKEIGINE); 
	m_ReturnCtrl.EnableWindow(TRUE);
	m_CHECKEIGINEc.SetCheck(m_CHECKEIGINE); 
	m_CHECKEIGINEc.UpdateData(TRUE);	
}

/***********************************************************************/

void TestingDlg::OnEbn() 
{Tstr->OnEbn(&m_EBN); m_EBNc.SetCheck(m_EBN); m_EBNc.UpdateData(TRUE);	m_ReturnCtrl.EnableWindow(TRUE);
}

void TestingDlg::OnCondition() 
{Tstr->OnCondition(&m_CONDITION); m_CONDITIONc.SetCheck(m_CONDITION); m_CONDITIONc.UpdateData(TRUE); m_ReturnCtrl.EnableWindow(TRUE);}

void TestingDlg::OnAdsorber() 
{Tstr->OnAdsorber(&m_ADSORBER); m_ADSORBERc.SetCheck(m_ADSORBER); m_ADSORBERc.UpdateData(TRUE); m_ReturnCtrl.EnableWindow(TRUE);}

void TestingDlg::OnFan() 
{Tstr->OnFan(&m_FAN); m_FANc.SetCheck(m_FAN); m_FANc.UpdateData(TRUE); m_ReturnCtrl.EnableWindow(TRUE);}


/***********************************************************************/

void TestingDlg::OnTestButton() 
{
	if (Tstr->Connected){
		DinamicsTest	DT;
		DT.DoModal();
	}
}

/***********************************************************************/

void TestingDlg::OnM154n() {
	m_M154Nc.UpdateData(TRUE);
	m_M154N=!m_M154N;
	Tstr->SetM154N(m_M154N);
	RefControls();
	m_M154Nc.UpdateData(TRUE);
}

/***********************************************************************/
extern uart	*urt;
void TestingDlg::OnSaveButton() 
{
FILE	*stream;
time_t	ltime;
int i;

if (Tstr->Connected)
{
	IdleTimer=TRUE;
	if ( Filename.GetLength() < 1 )	{ CFileDialog CF( FALSE, ".tdm", "TSTRDMP", OFN_PATHMUSTEXIST|OFN_NOREADONLYRETURN|OFN_CREATEPROMPT|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, szFilter, NULL );	CF.DoModal(); Filename=CF.GetPathName();}
//   1-2
	if( (stream = fopen(Filename,"ab")) == NULL ) {MessageBox("   ."," ", MB_OK | MB_ICONSTOP ); return;}
    else {		
		fprintf(stream, "\r\n\r\n\r\n \t ******************************************* \r\n");
		fprintf(stream,             " \t ***    . *** \r\n");
		fprintf(stream,             " \t ******************************************* \r\n\t\t:");
        time( &ltime ); 
		fprintf(stream, "%.24s\r\n", asctime( localtime( &ltime ) ));
CommentDlg	CD;
	CD.DoModal();
		if (CD.m_Comment.GetLength()!=0) fprintf(stream, ": %s\r\n", CD.m_Comment );
Tstr->ReadParams();
///*/*/for (i=0;i<50;i++) fprintf(stream," %2X", urt->rMessage[i]);
		fprintf(stream, "\r\n   (TWAT):\t\t%i\t. .", Tstr->_TWAT );
		fprintf(stream, "\r\n    (TAIR):\t\t\t%i\t. .", Tstr->_TAIR );
		fprintf(stream, "\r\n  / (VALF):\t\t\t%.3f", Tstr->_VALF );   
		fprintf(stream, "\r\n   (THR):\t\t\t%u\t%%", Tstr->_THR );   
		fprintf(stream, "\r\n    (FREQ):\t\t\t%u\t./.", Tstr->_FREQ );   
		fprintf(stream, "\r\n       (FREQXX):\t%u\t./.", Tstr->_FREQXX );   
		fprintf(stream, "\r\n      (FSM):\t%u\t.", Tstr->_FSM );   
		fprintf(stream, "\r\n     1 (COEFF1):\t%.4f", Tstr->_COEFF1 );   
		fprintf(stream, "\r\n     1 (COEFF2):\t%.4f", Tstr->_COEFF2 );   
		fprintf(stream, "\r\n   (PABS):\t\t\t\t%.4f", Tstr->_PABS );   
		fprintf(stream, "\r\n    (FAZ):\t\t\t\t%u\t.", Tstr->_FAZ );   
		fprintf(stream, "\r\n    (UOZ):\t\t\t%u\t.", Tstr->_UOZ );   
		fprintf(stream, "\r\n   (SPD):\t\t\t\t%u\t./.", Tstr->_SPD );   
		fprintf(stream, "\r\n   (NUACC):\t\t\t\t%.2f\t.", Tstr->_NUACC );   
//		fprintf(stream, "\r\n     (JUFRXX):\t\t%u\t./.", Tstr->_JUFRXX );   
		fprintf(stream, "\r\n     1 (LAM1):\t\t%u\tB.", Tstr->_LAM1 );	
		fprintf(stream, "\r\n     2 (LAM2):\t\t%u\tB.", Tstr->_LAM2 );	
		fprintf(stream, "\r\n     (O2FLAGS):\t\t%x", Tstr->_O2FLAGS );   
		fprintf(stream, "\r\n    (INJ):\t\t\t%.2f\t.", Tstr->_INJ );   
		fprintf(stream, "\r\n    (JAIR):\t\t\t%.3f\t./.", Tstr->_JAIR );   
		fprintf(stream, "\r\n    (JQT):\t\t\t\t%.2f\t./.", Tstr->_JQT );   
		fprintf(stream, "\r\n    (JQK):\t\t\t\t%.2f\t./100.", Tstr->_JQK );   
		fprintf(stream, "\r\n    (RCOK):\t\t%.3f",Tstr->_RCOK);	
		fprintf(stream, "\r\n       (RCOD):\t%.3f",Tstr->_RCOD);	
		fprintf(stream, "\r\n     (UOZOC):\t\t%.3f\t.",Tstr->_UOZOC);	
		fprintf(stream, "\r\n  (SSM):\t\t\t\t\t%u\t",Tstr->_SSM);	
		fprintf(stream, "\r\n    (UGB):\t\t\t\t%.2f\t/",Tstr->_UGB);	

		fprintf(stream, "\r\n:\r\n (BITSTP):%u",Tstr->_BITSTP);	
		fprintf(stream, "\r\n  (RXX):%u",Tstr->_RXX);	
		fprintf(stream, "\r\n   (BLKINJ):%u",Tstr->_BLKINJ);	
		fprintf(stream, "\r\n   (BITPOW):%u",Tstr->_BITPOW);	
		fprintf(stream, "\r\n   . (WRKLAM):%u",Tstr->_WRKLAM);	
		fprintf(stream, "\r\n     (RDET):%u",Tstr->_RDET);	
		fprintf(stream, "\r\n  (ADSORBER):%u",Tstr->_ADSORBER);	
		fprintf(stream, "\r\n     (BITATM):%u",Tstr->_BITATM);	
		fprintf(stream, "\r\n    TABKF1 (TKFWR1):%u",Tstr->_TKFWR1);	
		fprintf(stream, "\r\n    TABKF2 (TKFWR2):%u",Tstr->_TKFWR2);	
		fprintf(stream, "\r\n . 1 L- ./. (INPLAM1):%u",Tstr->_INPLAM1);	
		fprintf(stream, "\r\n . 2 L- ./. (INPLAM2):%u",Tstr->_INPLAM2);	
		fprintf(stream, "\r\n (DET):%u",Tstr->_DET);	
		fprintf(stream, "\r\n    (BDET):%X",Tstr->_BDET);	
		fprintf(stream, "\r\n  (CHECKEIGINE):%u",Tstr->_CHECKEIGINE);	

		fprintf(stream, "\r\n\r\n :\t");   
 CString	TmpS;
		Tstr->GetERRORS_L(&TmpS);  
		fprintf(stream, "%s \r\n", TmpS); 
		Tstr->ReadVIN();
		if (Tstr->sVIN.Present==-1) {
			fprintf(stream, "\r\n  :",Tstr->sVIN.MikasType);
			i=0; while (Tstr->sVIN.dataPasp[i]!=0) 
					{if ((Tstr->sVIN.dataPasp[i]=='\r')|(Tstr->sVIN.dataPasp[i]=='\n')) Tstr->sVIN.dataPasp[i]=' '; i++;}
			i=0; while (Tstr->sVIN.progPasp[i]!=0) 
					{if ((Tstr->sVIN.progPasp[i]=='\r')|(Tstr->sVIN.progPasp[i]=='\n')) Tstr->sVIN.progPasp[i]=' '; i++;}
			fprintf(stream, "\r\n  \t:%s",Tstr->sVIN.progPasp);
			fprintf(stream, "\t\t  :\t%s",Tstr->sVIN.dataPasp);
			fprintf(stream, "\r\n  :\t%s", Tstr->sVIN.vNAMEBL);
			fprintf(stream, "\t\t   :\t%s",	Tstr->sVIN.vNUMBL);
			fprintf(stream, "\r\n   :\t%s",	Tstr->sVIN.vDATBL);
			fprintf(stream, "\t\t  ADC:\t\t%s",	Tstr->sVIN.vKADC0);
			fprintf(stream, "\r\n  :\t\t%s",	Tstr->sVIN.vNUMENG);
			fprintf(stream, "\t\t  :\t\t%s",	Tstr->sVIN.vNUMCAR);
			fprintf(stream, "\r\n   :\t\t%s",	Tstr->sVIN.vDATENG);
			Tstr->sVIN.Present=0;
		}	
		Tstr->COMPLECTATION(&TmpS);
		fprintf(stream, "\r\n\r\n: %s", LPCTSTR(TmpS) );
		/*    */
		fclose(stream);
		}
	IdleTimer=FALSE;
}	
}

/***********************************************************************/

void TestingDlg::OnSelchangeCom() 
{
	COM_Port=m_COMc.GetCurSel()+2; 
	m_COMc.SetCurSel(COM_Port-2);	
}

/***********************************************************************/

void TestingDlg::OnIdentButton() 
{
	if (Tstr->ReadVIN())	{	VINDlg	VD;	VD.DoModal();}
}

/***********************************************************************/

void TestingDlg::OnMechButton() 
{
	if (Tstr->Connected){
		MechanicTest	MT;
		MT.DoModal();
	}
	
}

/***********************************************************************/


void TestingDlg::OnAccButton() 
{
	if (Tstr->Connected){
		AccTest	MT;
		MT.DoModal();
	}
	
}

/*
UINT	MyThreadProc(LPVOID p)
{
CommentDlg	CD;
char	comm[6], resp[20], len;

	CD.m_Comment="0x0 0x0 0x0";

	CD.DoModal();
	if (CD.m_Comment.GetLength()!=0) 
	{
		len=sscanf((LPCSTR)CD.m_Comment, "%x%x%x%x", &comm[0], &comm[1], &comm[2], &comm[3] );	
		if (Tstr->SendCommand(comm, len, resp,20))
		{ sprintf((char *)(LPCSTR)CD.m_Comment,"%2.2X %2.2X %2.2X %2.2X %2.2X %2.2X %2.2X ...", 
											resp[0], resp[1], resp[2], resp[3], resp[4], resp[5], resp[6]);		  
		}
		else CD.m_Comment="Timeout !!!";
//	CD.DoModal();
	}
	AfxEndThread(0);
return 0;
}
*/
void TestingDlg::OnCommanda() 
{
	// TODO: Add your control notification handler code here
/*CommentDlg	CD;
char	comm[6], resp[20], len,str[100];

	CD.m_Comment="0x0 0x0 0x0";

//	CWinThread* MyThreadp=AfxBeginThread(MyThreadProc, THREAD_PRIORITY_NORMAL,0,0,NULL);

	CD.DoModal();
	if (CD.m_Comment.GetLength()!=0) 
	{
		len=sscanf((LPCSTR)CD.m_Comment, "%x%x%x%x", &comm[0], &comm[1], &comm[2], &comm[3] );	
		if (Tstr->SendCommand(comm, len, resp,20))
		{ sprintf(str,"%2.2X %2.2X %2.2X %2.2X %2.2X %2.2X %2.2X ...", 
											resp[0], resp[1], resp[2], resp[3], resp[4], resp[5], resp[6]);		  
		CD.m_Comment=str;
		}
		else CD.m_Comment="Timeout !!!";
	CD.DoModal();
	}
*/
}

void TestingDlg::OnControlButton() 
{
	// TODO: Add your control notification handler code here
Controll	CD;
CD.DoModal();	
}


void TestingDlg::OnLzond() 
{
	Tstr->OnLZond(&m_LZond); m_LZondc.SetCheck(m_LZond); m_LZondc.UpdateData(TRUE);	m_ReturnCtrl.EnableWindow(TRUE);
}

void TestingDlg::OnDeton() 
{
	Tstr->OnDeton(&m_Deton); m_Detonc.SetCheck(m_Deton); m_Detonc.UpdateData(TRUE);	m_ReturnCtrl.EnableWindow(TRUE);
	
}

void TestingDlg::OnClrlam() 
{
		if ( MessageBox((LPCTSTR)"       ?",
			(LPCTSTR)" .", (UINT)MB_YESNO) == IDYES) 
					Tstr->ClrLZondAdopt();	
}

void TestingDlg::OnClrdet() 
{
	if ( MessageBox((LPCTSTR)"       ?",
			(LPCTSTR)" .", (UINT)MB_YESNO) == IDYES) 
					Tstr->ClrDetonAdopt();	
}

/*******************************************************************/


#define	NTOKENS		3

#define	COMNo				0
#define	AUTOSTRT			1


static struct Tokens	
{	char	Token[30];
//	int			ID;
} tn[NTOKENS]= {
	"COMNO",
	"AUTOSTART",
	0	
};



int	TestingDlg::ReadChain ()
{
FILE	*stream;
//int		handle;
char	buff[256];
size_t	sz;
int		CurrID,i,j, phi;
char	*strp,*sp;
//ObjChain	NullC;
//ObjChain	*CC=&NullC;
//ObjChain	*cc=&NullC;

//NObjects=0;
//if ( Filename.GetLength() < 1 )	{ CFileDialog CF( TRUE, ".cff", "MYTCfg", OFN_PATHMUSTEXIST, szFilter, NULL );	CF.DoModal(); Filename=CF.GetPathName();}
if( (stream = fopen("MYTCfg.cff","rt")) == NULL ) {/*MessageBox("   ."," ", MB_OK | MB_ICONSTOP ); */return 0;}
    else {		
	while	( (sz=fgets(buff, 255, stream ) != NULL) )
	{
	CurrID=-1;
	strupr(buff);
	for (i=0;i<NTOKENS;i++) if ( (strp=strstr(buff,(const char*)tn[i].Token)) != NULL ) {CurrID=i; break;}

	if ( (sp=strchr(strp,'\r'))!=NULL) *sp=0; if ( (sp=strchr(strp,'\n'))!=NULL) *sp=0; 

	switch(CurrID)
	{
	case -1: break;

	case COMNo:		strp=strchr(strp,'=')+1;
						COM_Port=atoi((const char *)strp)+1; 
						m_COMc.SetCurSel(COM_Port-2); 
						break;

	case AUTOSTRT:		OnStart(); break;
/*	case SaveDir:		strp=strchr(strp,'=')+1;
						strcpy(SaveDirectory,strp);
							urt->COM_Port=atoi((const char *)strp)+1; m_COMc.SetCurSel(COM_Port+1); break;
*/
	default: break;

	}
	}

	fclose(stream);
	}
return 0;
}

BOOL TestingDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	ReadChain();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void TestingDlg::OnCancelMode() 
{
	CDialog::OnCancelMode();
	
	// TODO: Add your message handler code here
}
