#if !defined(AFX_TESTINGDLG_H__D1F91EE3_2038_11D4_9F97_0000778B5537__INCLUDED_)
#define AFX_TESTINGDLG_H__D1F91EE3_2038_11D4_9F97_0000778B5537__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TestingDlg.h : header file
//

#include "mt.h"


/////////////////////////////////////////////////////////////////////////////
// TestingDlg dialog

class TestingDlg : public CDialog
{
// Construction
public:
		int	TestingDlg::ReadChain ();
		TestingDlg(CWnd* pParent = NULL);   // standard constructor
		TestingDlg::RefControls();
		TestingDlg::UpdateForm();
		TestingDlg::PrintCOMPLECTATION();
		TestingDlg::SetTesterStateText();
		TestingDlg::EnableControls(); 
		TestingDlg::DisableControls();
		TestingDlg::SetControls();
		TestingDlg::ReadParams();
		TestingDlg::RetCtrl();
void	ReadErrors(); 
void	osTimerProc();

// Dialog Data
	//{{AFX_DATA(TestingDlg)
	enum { IDD = IDD_TESTER_DIALOG };
	CButton	m_CLRLAM;
	CButton	m_CLRDET;
	CButton	m_LZondc;
	CButton	m_Detonc;
	CButton	m_CONTROL_BUTTON;
	CButton	m_ACC_BUTTONc;
	CButton	m_MECH_BUTTON;
	CButton	m_CLEARERR_BUTTON;
	CButton	m_DECODEERR_BUTTON;
	CButton	m_IDENT_BUTTON;
	CComboBox	m_COMc;
	CButton	m_SAVE_BUTTON;
	CButton	m_TEST_BUTTON;
	CButton	m_M154Nc;
	CButton	m_FANc;
	CButton	m_ADSORBERc;
	CButton	m_CONDITIONc;
	CButton	m_CHECKEIGINEc;
	CButton	m_EBNc;
	CButton	m_I23c;
	CButton	m_I14c;
	CButton	m_F4c;
	CButton	m_F3c;
	CButton	m_F2c;
	CButton	m_F1c;
	CButton	m_ReturnCtrl;
	CSpinButtonCtrl	m_SpinButton;
	CButton	m_START_BUTTON;
	UINT	m_FREQ;
	float	m_INJ;
	float	m_JAIR;
	float	m_JQK;
	float	m_JQT;
	float	m_NUACC;
	UINT	m_SPD;
	UINT	m_TAIR;
	UINT	m_THR;
	UINT	m_UOZ;
	float	m_VALF;
	UINT	m_FSM;
	CString	m_Connected;
	short	m_TWAT;
	UINT	m_NERRORS;
	CString	m_ERRORS;
	int		m_Timer;
	BOOL	m_F1;
	BOOL	m_F2;
	BOOL	m_F3;
	BOOL	m_F4;
	BOOL	m_I14;
	BOOL	m_I23;
	BOOL	m_EBN;
	BOOL	m_CHECKEIGINE;
	BOOL	m_CONDITION;
	BOOL	m_ADSORBER;
	BOOL	m_FAN;
	BOOL	m_M154N;
	BOOL	m_BITPOW;
	BOOL	m_BITSTP;
	BOOL	m_BLKINJ;
	BOOL	m_DET;
	BOOL	m_RXX;
	BOOL	m_WRKLAM;
	BOOL	m_RDET;
	UINT	m_FAZ;
	BOOL	m_ATM;
	UINT	m_LAM1;
	UINT	m_LAM2;
	BOOL	m_LAM1S;
	UINT	m_JDMM;
	float	m_COEFF1;
	float	m_COEFF2;
	BYTE	m_BDET;
	float	m_UGB;
	float	m_UOZOC;
	BOOL	m_Deton;
	BOOL	m_LZond;
	float	m_RCOK;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(TestingDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(TestingDlg)
	virtual void OnOK();
	afx_msg void OnStart();
	afx_msg void OnChangeTimer();
	afx_msg void OnButtonClrerr();
	afx_msg void OnF1();
	afx_msg void OnButtonDecodeerr();
	afx_msg void OnDestroy();
	afx_msg void OnReturnCtrl();
	afx_msg void OnF2();
	afx_msg void OnF3();
	afx_msg void OnF4();
	afx_msg void OnI14();
	afx_msg void OnI23();
	afx_msg void OnCheckeigine();
	afx_msg void OnEbn();
	afx_msg void OnCondition();
	afx_msg void OnAdsorber();
	afx_msg void OnFan();
	afx_msg void OnTestButton();
	afx_msg void OnM154n();
	afx_msg void OnSaveButton();
	afx_msg void OnSelchangeCom();
	afx_msg void OnIdentButton();
	afx_msg void OnMechButton();
	afx_msg void OnAccButton();
	afx_msg void OnCommanda();
	afx_msg void OnControlButton();
	afx_msg void OnLzond();
	afx_msg void OnDeton();
	afx_msg void OnClrlam();
	afx_msg void OnClrdet();
	virtual BOOL OnInitDialog();
	afx_msg void OnCancelMode();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	char			Regen;
	mt				Tester;

	UINT			ReadTimerID, ReadTimer;
	UINT			TmPeriod;
	BOOL			Started;
	BOOL			CntrlsEnabled;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTINGDLG_H__D1F91EE3_2038_11D4_9F97_0000778B5537__INCLUDED_)
