// uart.h: interface for the UART class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_UART_H__ACEEC7B1_737B_11D4_A831_0000778B5536__INCLUDED_)
#define AFX_UART_H__ACEEC7B1_737B_11D4_A831_0000778B5536__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



class uart  
{
public:
					uart();
	virtual			~uart();
	unsigned char	rMessage[BUFF_LEN];
	unsigned char	sMessage[BUFF_LEN];

	unsigned char	SendBytesGAZ(unchar Len);
	unsigned char	InitUart(int Port);
	unsigned char	WakeUpImpuls(int Port);
	void			ReceiveBytes(void);
	void			SetRxTimeOut(unsigned short Time);
	BOOL			FrameNotReceived;
	BOOL			UartInited;
	void			CloseUart();
	void			ErrMessageBox(char *TitleString);

	unsigned char	SMess_Len, SMess_Ptr;
	unsigned char	RMess_Len, RMess_Ptr;
	unsigned char	RFrm_Len; //   .
	short			BadCRC;
	short			NotToTester;
	short			NotFromMIKAS;
	short			FramesReceived;
	short			BytesReceived;
	int				COM_Port;


private:
	BOOL			Was40;
	void			FlushUart( void );
	unchar			ParseByteGAZ(unchar RByte);
	unchar			ReadByte();
	void			WriteBytes(unchar *Message_P,unchar Len);

	unchar			sMess_Len;
	unchar			sFrm_Len; //   .

	TCHAR			PortCom1[6]; 
	TCHAR			PortCom2[6]; 
	TCHAR			PortCom3[6]; 
	TCHAR			PortCom4[6]; 

	TCHAR			*pcComPort;
	HANDLE			hComPort; 
	DCB				m_dcb;  
	COMMTIMEOUTS	sTimeouts; 
	char			UARTErrors;
	unsigned long	RxTimeout;
	BOOL			TimeIsOut;
	unsigned short	Timeout; 

};

#endif // !defined(AFX_UART_H__ACEEC7B1_737B_11D4_A831_0000778B5536__INCLUDED_)

